##
##  nci.spec -- OpenPKG RPM Package Specification
##  Copyright (c) 2000-2021 OpenPKG Project <http://openpkg.org/>
##
##  Permission to use, copy, modify, and distribute this software for
##  any purpose with or without fee is hereby granted, provided that
##  the above copyright notice and this permission notice appear in all
##  copies.
##
##  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
##  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
##  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
##  IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
##  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
##  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
##  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
##  USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
##  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
##  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
##  OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
##  SUCH DAMAGE.
##

#   package version
%define       V_nci      1.0.27
%define       V_nci_snap 20210404

#   package information
Name:         nci
Summary:      Node Continuous Integration Server
URL:          https://github.com/node-ci/nci/
Vendor:       Oleg Korobenko, Vladimir Polyakov
Packager:     OpenPKG Project
Distribution: OpenPKG Community
Class:        EVAL
Group:        Language
License:      MIT
Version:      %{V_nci}
Release:      20210404

#   list of sources
Source0:      http://download.openpkg.org/components/versioned/nci/nci-%{V_nci}-%{V_nci_snap}.tar.xz
Source1:      nci.sh
Source2:      preload.json
Source3:      config.yaml
Source4:      project.yaml

#   build information
BuildPreReq:  OpenPKG, openpkg >= 20160101, node-openpkg
PreReq:       OpenPKG, openpkg >= 20160101, node

%description
    Flexible, open source continuous integration server written in Node.js.

%track
    prog nci = {
        version   = %{version}
        url       = https://github.com/node-ci/nci/releases
        regex     = v(\d+\.\d+\.\d+)\.tar\.gz
    }

%prep
    %setup -q -c

%build
    %{l_prefix}/bin/node-openpkg squeeze

%install
    #   create installation hierarchy
    %{l_shtool} mkdir -f -p -m 755 \
        $RPM_BUILD_ROOT%{l_prefix}/etc/nci/projects/example \
        $RPM_BUILD_ROOT%{l_prefix}/sbin \
        $RPM_BUILD_ROOT%{l_prefix}/lib/nci

    #   install wrapper script
    %{l_shtool} install -c -m 755 %{l_value -s -a} \
        %{SOURCE nci.sh} \
        $RPM_BUILD_ROOT%{l_prefix}/sbin/nci

    #   install configuration files
    %{l_shtool} install -c -m 644 %{l_value -s -a} \
        %{SOURCE preload.json} %{SOURCE config.yaml} \
        $RPM_BUILD_ROOT%{l_prefix}/etc/nci/
    %{l_shtool} install -c -m 644 %{l_value -s -a} \
        %{SOURCE project.yaml} \
        $RPM_BUILD_ROOT%{l_prefix}/etc/nci/projects/example

    #   install program
    %{l_prefix}/bin/node-openpkg install \
        %{l_prefix}/lib/nci/

    #   determine installation files
    %{l_rpmtool} files -v -ofiles -r$RPM_BUILD_ROOT %{l_files_std}

%files -f files

%clean

